#ifndef __MODULE_H
#define __MODULE_H

struct module_context;
struct ui_module {
	const char *name;
	void (*starter)(struct module_context *);
	const char *description;
};

struct module_context {
	struct ui_module *self;
	char **upgrade_list;
	int upgrade_count;
	int mode;
	const char *root;
};

#ifdef MAIN_FILE
#ifdef ENABLE_MODULAR
void load_module(struct module_context *ctx);
#define grade_ui load_module
#define batch_ui load_module
#define newt_ui load_module
#define pi_ui load_module
#else
/* don't wanna grade and pi if not modular /klakier */
/* void grade_ui(struct module_context *ctx); */
void batch_ui(struct module_context *ctx);
#ifdef ENABLE_STATIC_GRADE
void grade_ui(struct module_context *ctx);
#endif
void newt_ui(struct module_context *ctx);
/* void pi_ui(struct module_context *ctx); */
#endif
#endif

#define BATCH_TMP_DB "/tmp/wuch-cache/tmp-chroot"

#endif /* __MODULE_H */
